/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginCrushTask = {};
pluginCrushTask.localization = {};
/****************************/

// Plugin details
var pluginName = "CrushTask";
var _plugin = $("#pnlPlugin" + pluginName);
var tasksList = $("#tasksList", _plugin);

// Localizations
pluginCrushTask.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	btnAddTaskText : " Add Task",
	btnEditTaskText : " Edit Selected ",
	btnRemoveTaskText : " Remove Selected ",
	btnMoveUpText : " Move Up ",
	btnMoveDownText : " Move Down ",
	lblSourceFilterText : "Source Filter :",
	lblMultiThreadedText : "Multi Threaded",
	lblOnErrorJumpToTaskNamedText : "On error, jump to task named : ",
	lblConfigTabText : "Config",
	lblVariablesTabText : "Variables",
	lblLoggingTabText : "Logging",
	lblHelpTabText : "Help",
	lblAs2TabOptionsText : "Options",
	lblAs2SigningTabText : "Signing",
	lblAs2EncryptingTabText : "Encrypting",
	lblAs2AsyncMDNText : "Async MDN",
	lblAs2UseCompressionText : "Use compression",
	lblmdnWaitSecondsText : "MDN Wait Timeout : ",
	lblmdnWaitSecondsNoteText : "(In Seconds)",
	lblAs2SignMessageText : "Sign Message : ",
	lblAs2EncryptMessageText : "Encrypt Message : ",
	lblAs2FromPartnerText : "From Partner : ",
	lblAs2ToPartnerText : "To Partner : ",
	lblAs2FromEmailText : "From Email : ",
	lblAs2SubjectText : "Subject : ",
	lblAs2RecipientURLText : "Recipient URL : ",
	lblAs2ResponseURLText : "Response URL : ",
	lblAs2KeystorePathText : "Keystore Path : ",
	lblAs2KeystoreFormatText : "Keystore Format : ",
	lblAs2KeystorePasswordText : "Keystore Password : ",
	lblAs2KeyPasswordText : "Key Password : ",
	lblAs2KeyNameText : "Key name (alias) : ",
	lblDestinationText : "Destination : ",
	lblWaitXSecondsText : "Wait x seconds to see if the file has changed : ",
	lblGiveUpAfterXSecondsText : "Give up after x seconds : ",
	lblRetryFailedCopiesXTimesText : "Retry failed copies x times : ",
	lblResumeCopyText : "Resume",
	lblResumeOnFailureCopyText : "Resume only on failure",
	lblAfterCopyingAddToListText : "After copying, add to list for future tasks.",
	lblDeleteTaskWarningText : " Be especially careful when using delete task as you colud delete the original and copy. ",
	lblKeepTryingForXSecondsText : "Keep trying for x seconds : ",
	lblFromText : "From : ",
	lblToText : "To : ",
	lblCCText : "CC : ",
	lblBCCText : "BCC : ",
	lblSubjectText : "Subject : ",
	lblBodyText : "Body : ",
	lblAttachFilesText : "Attach Files?",
	lblExecuteActionHelpText : "%user_name%, {real_path}, {path}, {name}, {size}, {speed}, {error}",
	lblCommandText : "Command : ",
	lblExamplesText : "Examples : ",
	lblArgumentText : "Argument : ",
	lblSeparatorText : "Separator : ",
	lblWorkingDirectoryText : "Working Directory : ",
	lblEnvironmentVarsText : "Environment Variables :",
	lblExecuteActionInstructionsText : ' Example: If the command was "cp" and the argument was "{real_path}:/archive/{name}" <br> Then, if a file was uploaded to "/uploads/stuff.zip", it would be copied to "/Archive/stuff.zip" <br> Note the purpose of the "." in that it separates argumets to the command. ',
	lblExcludeActionHelpText : " If an item matches the filter, it will be excluded from the future task processing. ",
	lblFindURLText : "Find URL : ",
	lblFindFilterText : "Find Filter : ",
	lblVerifyFilesAreNotChangingText : "Verify files are not changing",
	lblChangingAllText : "Wait for all files to stop changing",
	lblDepthText : "Depth : ",
	lblUseAbsolutePathsText : "Use absolute paths",
	lblLastModifiedText : "Last modified : ",
	lblFindCacheNameToUseText : "FindCache name to use : ",
	lblModifiedComparisonNewText : " Newer",
	lblModifiedComparisonOldText : " Older",
	lblDaysText : "Days : ",
	lblHoursText : "Hours : ",
	lblMinutesText : "Minutes : ",
	lblKeepCheckingForUpToXMinutesText : "Keep checking for up to x minutes : ",
	lblSecondsDelayBetweenScansText : "Seconds delay between scans : ",
	lblFailIfNoFilesFoundText : "Fail if no files are found",
	lblJumpToTaskText : "Jump to task : ",
	lblJumpToJobText : "Jump to job : ",
	lblFilterNoteText : "Leave both fields blank to always be a true condition.",
	lblContinueAfterJumpText : "Continue after jump",
	lblFindCacheNameText : "Cache Name : ",
	lblFindCachePathText : "Path to store cache file : ",
	lblFindCacheModeLabelText : "Mode : ",
	lblFindCacheReadText : "Read",
	lblFindCacheWriteText : "Write",
	lblFeatureNoteText : "This feature is only available in enterprise licenses.",
	lblHTTPUrlText : "URL : ",
	lblHTTPMethodText : "HTTP Method : ",
	lblHTTPUsernameText : "HTTP Username : ",
	lblHTTPPasswordText : "HTTP Password : ",
	lblHTTPRetryText : "Retry x times on failure : ",
	lblHTTPMaximumFileText : "Maximum files per event that post without delay : ",
	lblHTTPDelayText : "Delay between event posts : ",
	lblHTTPPostDataText : "POST Data : ",
	lblHTTPOnlyRecentText : "Only use most recent item.",
	lblDirectoryNameText : "Directory Name : ",
	lblDestinationText : "Destination : ",
	lblPGPKeyFileText : "Key file : ",
	lblPGPKeyPasswordText : "Key password (if any) : ",
	lblPGPEncryptionMethodText : "Method : ",
	lblPGPAsciiArmorText : "ASCII Armor?",
	lblPGPDeleteOriginalText : "Delete Original?",
	lblPreserveModifiedDateText : "Preserve modified date",
	lblPreviewActionHelpText : " Request this file be processed by the Preview function in the CrushFTP prefs. ",
	lblNewNameText : "New Name : ",
	lblKeepTryingForXSecondsText : "Keep trying for x seconds : ",
	lblSkipSubItemsIfParentIsRenamedText : "Skip sub items if parent is renamed.",
	lblVariableNameText : "Variable Name : ",
	lblVariableValueText : "Variable Value : ",
	lblDeleteOriginalZipText : "Delete original .zip",
	lblInternalUnzippingText : "Internal Unzipping",
	lblUnzipIntoOwnFolderText : "Unzip into its own folder.",
	lblExternalUnzipText : "External 'unzip' Unzipping",
	lblDestPathText : "Output Location : ",
	lblWaitXSecondsText : "Wait x seconds : ",
	lblWaitForPreviousThreadsToFinishText : "Wait for previous threads to finish.",
	lblFilePathText : "File Path : ",
	lblOverwriteText : "Overwrite?",
	lblContentsText : "Contents : ",
	lblInternalZippingText : "Internal Zipping",
	lblExternalZipText : "External 'zip' Zipping",
	btnApplyText : "Apply",
	lblLogSuccessText : "Log Success?",
	lblFileText : "File :",
	lblLineText : "Line :",
	lblLogFailureText : "Log Failure?",
	lblUserConnectionGroupText : "User Connection Group : ",
	lblFindUserFiltersText : "Find Username Filter : ",
	lblExcludeUserFiltersText : "Exclude Username Filter : ",
	lblTaskToCallText : "Task to call with user info : ",
	lblMailProtocolText : "Mail Protocol : ",
	lblMailHostText : "Mail Host : ",
	lblMailPortText : "Mail Port : ",
	lblMailUsernameText : "Mail Username : ",
	lblMailPassText : "Mail Password : ",
	lblMailInboxText : "Mail Inbox : ",
	lblProcessUnreadMsgsText : "Only process unread messages? ",
	lblMarkAsReadText : "Mark messages as read after processing? ",
	lblDeleteMailText : "Delete messages after processing? ",
	lblSubjectFilterText : "Subject Filter : ",
	lblFromFilterText : "From Filter : ",
	lblMailPathText : "Download files to here : ",
	lblMailFileNameText : "File Name : ",
	lblSaveAttachmentsText : "Save attachments? ",
	lblMinimumSizeText : "Minimum file size in bytes : ",
	lblFileFilterText : "Filename Filter : ",
	lblSaveEmailAsFileText : "Save body of email as file? "
};

// Assign localizations
if(localizations.panels["Plugins"])
	localizations.panels["Plugins"][pluginName] = $.extend(pluginCrushTask.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginCrushTask.init = function(pluginID, returnXML){
	pluginCrushTask.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginCrushTask.bindData(0, pluginID);
}

pluginCrushTask.defaultValues = {
	as2Action : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "As2"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "As2"}],
		key_path : [{text : ""}],
		as2EncryptKeyPassword : [{text : ""}],
		as2EncryptKeystorePath : [{text : ""}],
		as2EncryptKeystorePassword : [{text : ""}],
		as2EncryptKeystoreFormat : [{text : "JKS"}],
		as2EncryptKeyAlias : [{text : ""}],
		as2EncryptType : [{text : "none"}],
		as2SignKeyAlias : [{text : ""}],
		as2SignKeyPassword : [{text : ""}],
		as2SignKeystoreFormat : [{text : "JKS"}],
		as2SignKeystorePassword : [{text : ""}],
		as2SignType : [{text : "none"}],
		as2SignKeystorePath : [{text : ""}],
		as2RecipientUrl : [{text : ""}],
		as2ToPartner : [{text : ""}],
		as2AsyncMdn : [{text : "false"}],
		as2Compress : [{text : "false"}],
		as2FromPartner : [{text : ""}],
		as2Subject : [{text : ""}],
		as2From : [{text : ""}],
		as2ResponseUrl : [{text : ""}]
	},
	copyAction : {
		addAfterCopy : [{text : "false"}],
		changed : [{text : "2"}],
		changedTimeout : [{text : "60"}],
		destPath : [{text : "{path}{stem}{ext}"}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Copy"}],
		preserveModifiedDate : [{text : "true"}],
		retry : [{text : "0"}],
		sourceFilter : [{text : "*"}],
		ssh_private_key : [{text : ""}],
		ssh_private_key_pass : [{text : ""}],
		ssh_two_factor : [{text : "false"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Copy"}]
	},
	deleteAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Delete"}],
		retry : [{text : "10"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Delete"}]
	},
	emailAction : {
		attachFiles : [{text : "false"}],
		emailBcc : [{text : ""}],
		emailBody : [{text : ""}],
		emailCc : [{text : ""}],
		emailFrom : [{text : ""}],
		emailSubject : [{text : ""}],
		emailTo : [{text : ""}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Email"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Email"}]
	},
	executeAction : {
		argument : [{text : ""}],
		command : [{text : ""}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Execute"}],
		separator : [{text : ";"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		workingDirectory : [{text : "real_path"}],
		type : [{text : "Execute"}]
	},
	excludeAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Exclude"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Exclude"}]
	},
	findAction : {
		absolute_paths : [{ text : "true"}],
		changing : [{ text : "true"}],
		changingAll : [{ text : "true"}],
		days : [{ text : "0"}],
		depth : [{ text : "1"}],
		cache_name : [{ text : ""}],
		fail_jump : [{text : ""}],
		fail_no_files : [{ text : "false"}],
		failure_log : [{ text : "false"}],
		failure_log_file : [{ text : "./failure.log"}],
		failure_log_line : [{ text : "FAIL : {taskName}{r}{n}"}],
		findFilter : [{ text : "*"}],
		findUrl : [{ text : "{path}"}],
		hours : [{ text : "0"}],
		minutes : [{ text : "0"}],
		multiThreaded : [{ text : "false"}],
		name : [{ text : "Find"}],
		retry_delay : [{ text : "0"}],
		retry_minutes : [{ text : "0"}],
		sourceFilter : [{ text : "*"}],
		ssh_private_key : [{text : ""}],
		ssh_private_key_pass : [{text : ""}],
		ssh_two_factor : [{ text : "false"}],
		success_log : [{ text : "false"}],
		success_log_file : [{ text : "./success.log"}],
		success_log_line : [{ text : "OK : {taskName}{r}{n}"}],
		type : [{ text : "Find"}],
		modified_comparison : [{ text : "new"}]
	},
	findcacheAction : {
		fail_jump : [{text : ""}],
		fail_no_files : [{ text : "false"}],
		failure_log : [{ text : "false"}],
		failure_log_file : [{ text : "./failure.log"}],
		failure_log_line : [{ text : "FAIL : {taskName}{r}{n}"}],
		cache_folder : [{ text : ""}],
		cache_mode : [{ text : "read"}],
		cache_name : [{ text : "CacheItem"}],
		multiThreaded : [{ text : "false"}],
		name : [{ text : "Find"}],
		sourceFilter : [{ text : "*"}],
		success_log : [{ text : "false"}],
		success_log_file : [{ text : "./success.log"}],
		success_log_line : [{ text : "OK : {taskName}{r}{n}"}],
		type : [{ text : "FindCache"}]
	},
	jumpAction : {
		fail_jump : [{text : ""}],
		failure_log : [{ text : "false"}],
		failure_log_file : [{ text : "./failure.log"}],
		failure_log_line : [{ text : "FAIL : {taskName}{r}{n}"}],
		jump_job : [{text : ""}],
		jump_task : [{text : ""}],
		multiThreaded : [{ text : "false"}],
		name : [{ text : "Jump"}],
		sourceFilter : [{ text : "*"}],
		success_log : [{ text : "false"}],
		success_log_file : [{ text : "./success.log"}],
		success_log_line : [{ text : "OK : {taskName}{r}{n}"}],
		continueJump : [{ text : "true"}],
		variable2 : [{ text : ""}],
		variable1 : [{ text : ""}],
		variableCondition : [{ text : "contains"}],
		type : [{ text : "Jump"}]
	},
	httpAction : {
		fail_jump : [{text : ""}],
		failure_log : [{ text : "false"}],
		failure_log_file : [{ text : "./failure.log"}],
		failure_log_line : [{ text : "FAIL : {taskName}{r}{n}"}],
		destUrl : [{text : "http://domain.com/?file={path}"}],
		recent : [{text : "false"}],
		httpMethod : [{ text : "POST"}],
		name : [{ text : "Http"}],
		sourceFilter : [{ text : "*"}],
		success_log : [{ text : "false"}],
		success_log_file : [{ text : "./success.log"}],
		success_log_line : [{ text : "OK : {taskName}{r}{n}"}],
		retries : [{ text : "0"}],
		maxFiles : [{ text : "100"}],
		delay : [{ text : "1000"}],
		post : [{ text : ""}],
		type : [{ text : "Http"}]
	},
	makedirectoryAction : {
		destPath : [{text : "{path}new_folder"}],
		fail_jump : [{text  :  ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "MakeDirectory"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "MakeDirectory"}]
	},
	moveAction : {
		destPath : [{text : "{path}{stem}{ext}"}],
		fail_jump : [{text  :  ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Move"}],
		preserveModifiedDate : [{text : "true"}],
		sourceFilter : [{text : "*"}],
		ssh_private_key : [{text  :  ""}],
		ssh_private_key_pass : [{text  :  ""}],
		ssh_two_factor : [{text : "false"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Move"}]
	},
	pgpAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Pgp"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Pgp"}],
		key_path : [{text : ""}],
		ascii_armor : [{text : "false"}],
		key_password : [{text : ""}]
	},
	popimapAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "PopImap"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "PopImap"}],
		destPath : [{text : ""}],
		findUrl : [{text : ""}],
		mail_attachments : [{text : "true"}],
		mail_body : [{text : "false"}],
		mail_delete : [{text : "false"}],
		mail_file_filter : [{text : "*"}],
		mail_from_filter : [{text : "*"}],
		mail_host : [{text : "imap.gmail.com"}],
		mail_name : [{text : "msg_{mail_index}.{mail_type}"}],
		mail_pass : [{text : ""}],
		mail_path : [{text : ""}],
		mail_port : [{text : "993"}],
		mail_protocol : [{text : "imaps"}],
		mail_read : [{text : "true"}],
		mail_size : [{text : "0"}],
		mail_subject_filter : [{text : "*"}],
		mail_unread : [{text : "true"}],
		mail_user : [{text : ""}],
    	mail_inbox : [{text : "Inbox"}]
	},
	previewAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Preview"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Preview"}]
	},
	renameAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Rename"}],
		newName : [{text : "{stem}{ext}"}],
		retry : [{text : "10"}],
		skipSubitems : [{text : "true"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Rename"}]
	},
	userslistAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "UserVariable"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "UsersList"}],
		destPath: [{text : ""}],
		excludeUserFilters: [{text : "default,TempAccount,anonymous"}],
		findUrl: [{text : ""}],
		findUserFilters: [{text : "*"}],
		taskToCall: [{text : ""}],
		userConnectionGroup: [{text : "MainUsers"}]
	},
	uservariableAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "UserVariable"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "UserVariable"}],
		varName : [{text : "myVariable"}],
		varValue : [{text : "10"}]
	},
	unzipAction : {
		delete_zip : [{text : "false"}],
		external_zip : [{text : "false"}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		internal_zip : [{text : "true"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Unzip"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Unzip"}],
		unzip_in_folder : [{text : "false"}]
	},
	waitAction : {
		delay : [{text : "1"}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Wait"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Wait"}],
		waitThreads : [{text : "false"}]
	},
	writefileAction : {
		afterContent : [{text : ""}],
		beforeContent : [{text : "<LINE><item> <title>{name}</title> <description>{path}</description> <link>{url}</link> </item>{r}{n}</LINE>"}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		fileContents : [{text : "<?xml version=\"1.0\" ?>\r\n<rss version=\"2.0\">\r\n<channel>\r\n<title>New Files</title>\r\n<description>Incoming files...</description>\r\n<link>http : //www.crushftp.com</link>\r\n</channel>\r\n</rss>"}],
		filePath : [{text : ""}],
		findAfter : [{text : ""}],
		findBefore : [{text : "</channel>"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "WriteFile"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "WriteFile"}]
	},
	zipAction : {
		external_zip : [{text : "false"}],
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		filePath : [{text : "/archives/newArchive.zip"}],
		internal_zip : [{text : "true"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Zip"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Zip"}]
	},
	customAction : {
		fail_jump : [{text : ""}],
		failure_log : [{text : "false"}],
		failure_log_file : [{text : "./failure.log"}],
		failure_log_line : [{text : "FAIL : {taskName}{r}{n}"}],
		multiThreaded : [{text : "false"}],
		name : [{text : "Custom"}],
		sourceFilter : [{text : "*"}],
		success_log : [{text : "false"}],
		success_log_file : [{text : "./success.log"}],
		success_log_line : [{text : "OK : {taskName}{r}{n}"}],
		type : [{text : "Custom"}]
	}
};

pluginCrushTask.bindData = function(index, pluginID)
{
	$("div.pluginDetails, div.actionConfigPanel").hide();
	index = index || 0;
	var pluginPrefs = [];
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		if(curPlugin.subItem && curPlugin.subItem.length>0)
			_plugin.attr("subPluginName", curPlugin.subItem[0].text || false);
		bindValuesFromXML(_plugin, curPlugin);
		tasksList.empty();
		if(curPlugin && curPlugin["tasks"])
		{
			var tasks = curPlugin["tasks"];
			if(tasks.length>0)
			{
				tasks = tasks[0]["tasks_subitem"];
				if(tasks)
				{
					for(var i=0;i<tasks.length;i++)
					{
						var curItem = tasks[i];
						if(curItem && curItem.name && curItem.name.length>0)
						{
							var name = unescape(curItem.name[0].text);
							var type = curItem.type[0].text;
							var newControl = $("<li class='ui-widget-content' pluginType='"+type.toString().toLowerCase() +"'>" + name + " : " + type +"</li>");
							tasksList.append(newControl);
							if(type.toString().toLowerCase() == "find" && typeof curItem.changingAll == "undefined")
							{
								curItem.changingAll = [{ text : "true"}];
							}
							newControl.data("controlData", curItem);
						}
					}
				}
			}
		}
	}
	pluginCrushTask.bindEvents();
}

pluginCrushTask.bindEvents = function()
{
	if(this.eventAdded)return;
	tasksList.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			tasksList.find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			pluginCrushTask.bindPluginDetails(selected);
			pluginCrushTask.bindTextChangeEvents();
			return false;
		}
	});

	_plugin.find("#mail_protocol").change(function(){
		var protocol = $(this).val();
		if(protocol=="imaps")
		{
			$("#mail_port", _plugin).val("993").trigger("change");
		}
		else if(protocol=="imap")
		{
			$("#mail_port", _plugin).val("143").trigger("change");
		}
		else if(protocol=="pop3s")
		{
			$("#mail_port", _plugin).val("995").trigger("change");
		}
		else if(protocol=="pop3")
		{
			$("#mail_port", _plugin).val("110").trigger("change");
		}
	})

	_plugin.find("#example").change(function(){
		var val = $(this).val();
		if(val == "1")
		{
			$("#command", _plugin).val("cp");
			$("#argument", _plugin).val("{real_path}:/archive/{name}");
		}
		else if(val == "2")
		{
			$("#command", _plugin).val("mv");
			$("#argument", _plugin).val("{real_path};/processing/new files/{name}");
		}
		else if(val == "3")
		{
			$("#command", _plugin).val("/Applications/MyApp.app/Contents/MacOS/MyApp");
			$("#argument", _plugin).val("{real_path}");
		}
		else if(val == "4")
		{
			$("#command", _plugin).val("open");
			$("#argument", _plugin).val("{real_path}");
		}
		else
		{
			$("#command, #argument", _plugin).val("");
		}
		$("#command, #argument", _plugin).trigger("change");
	});

	$("a#moveTaskUp, a#moveTaskDown", _plugin).click(function(){
		if(tasksList.find("li.ui-widget-header").length>0)
		{
			var selected = tasksList.find("li.ui-widget-header");
			if($(this).is("#moveTaskUp") && selected.prev("li").length>0)
			{
				selected.prev("li").before(selected);
				panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
				pluginCrushTask.bindPluginDetails(selected);
			}
			else if($(this).is("#moveTaskDown") && selected.next("li").length>0)
			{
				selected.next("li").after(selected);
				panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
				pluginCrushTask.bindPluginDetails(selected);
			}
		}
		return false;
	});

	$("a#removeTask", _plugin).click(function(){
		common.UI.removeItem(tasksList, function(selected){
			panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
			pluginCrushTask.bindPluginDetails(selected);
		});
		return false;
	});

	$("a#addNewTask", _plugin).click(function(control){
			var actionType =  "";
			var actionName = "";
			if(control)
			{
				actionType = getTextValueFromXMLNode(control.type, "");
				actionName = getTextValueFromXMLNode(control.name, "");
			}
			jPrompt("Choose a task type:", actionType, "Tasks", function(value){
				actionType = value;
				if(actionType!=null)
				{
					if(actionType.length == 0)
					{
						$("#addNewLabel", _panel).trigger("click");
						return;
					}
					actionName = actionName || actionType;
					jPrompt("Enter a name for this task:", actionName, "Name", function(value){
						actionName = value;
						if(actionName)
						{
							var newControl = $("<li class='ui-widget-content' pluginType='"+actionType.toString().toLowerCase() +"'>" + actionName + " : " + actionType +"</li>");
							tasksList.append(newControl);
							newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-widget-header");
							newControl.addClass("ui-widget-header").addClass("ui-widget-header");
							var data = pluginCrushTask.defaultValues[actionType.toString().toLowerCase() + "Action"];
							data = $.extend(true, {}, data);
							if(data)
							{
								data.name = [{text:actionName}];
								newControl.data("controlData", data);
							}
							pluginCrushTask.bindPluginDetails(newControl);
						}
						panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
					});
				}
			}, ['As2',
					'Copy',
					'Delete',
					'Email',
					'Execute',
					'Exclude',
					'Find',
					'FindCache',
					'Jump',
					'HTTP',
					'MakeDirectory',
					'Move',
					'Pgp',
					'PopImap',
					'Preview',
					'Rename',
					'UsersList',
					'UserVariable',
					'Unzip',
					'Wait',
					'WriteFile',
					'Zip',
					'Custom']
			);
		return false;
	});

	$("a#editTask", _plugin).click(function(){
			var control = tasksList.find("li.ui-widget-header");
			var actionName = "";
			var actionType = "";
			var controlData = false;
			if(control)
			{
				controlData = control.data("controlData");
				actionName = getTextValueFromXMLNode(controlData.name, "");
				actionType = getTextValueFromXMLNode(controlData.type, "");
			}
			else
			{
				return false;
			}
			jPrompt("Enter a name for this task : ", actionName, "Name", function(value){
				actionName = value;
				if(actionName)
				{
					var newControl = $("<li class='ui-widget-content' pluginType='"+actionType.toString().toLowerCase() +"'>" + actionName + " : " + actionType +"</li>");
					control.replaceWith(newControl);
					if(controlData && controlData.name)
					{
						controlData.name[0].text = actionName;
					}
					newControl.data("controlData", controlData);
					pluginCrushTask.bindPluginDetails(newControl);
				}
				panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
			});
		return false;
	});

	pluginCrushTask.bindTextChangeEvents();

	_plugin.find(".SSHOptionsHandle").each(function(){
			$(this).bind("textchange", function(){
				if($(this).val().toLowerCase().indexOf("sftp://")>=0)
				{
					$(this).closest("div").find("div.sftpOptions").show();
				}
				else
				{
					$(this).closest("div").find("div.sftpOptions").hide();
				}
			});
	});

	$("a.serverFilePickButton", _plugin).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _plugin).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	this.eventAdded = true;
}

pluginCrushTask.bindTextChangeEvents = function()
{
	var pluginDetails = $("div#taskDetails");
	pluginDetails.find("input, select, textarea").bind("change", function(){
		var item = tasksList.find("li.ui-widget-header");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			if($(this).attr("id") == "modified_comparison_newer" && $(this).is(":checked"))
			{
				data["modified_comparison"] = [{text:"new"}];
			}
			else if($(this).attr("id") == "modified_comparison_older" && $(this).is(":checked"))
			{
				data["modified_comparison"] = [{text:"old"}];
			}
			else if($(this).attr("id") == "cache_mode_read" && $(this).is(":checked"))
			{
				data["cache_mode"] = [{text:"read"}];
			}
			else if($(this).attr("id") == "cache_mode_write" && $(this).is(":checked"))
			{
				data["cache_mode"] = [{text:"write"}];
			}
			else
			{
				var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
				data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
				if($(this).attr("id") == "type")
				{
					item.text($(this).val());
				}
			}
		}
		item.data("controlData", data);
		panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
	});

	pluginDetails.parent().find("#enabled, #debug").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
	});

	pluginDetails.find("input[type='text'], textarea").bind("textchange", function(){
		var item = tasksList.find("li.ui-widget-header");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
			data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
			if($(this).attr("id") == "type")
			{
				item.text($(this).val());
			}
		}
		item.data("controlData", data);
		panelPlugins.itemsChanged(true, pluginCrushTask.returnXML, pluginName);
	});
}

pluginCrushTask.bindPluginDetails = function(task)
{
	$("div.pluginDetails, div.actionConfigPanel").hide();
	if(!task)
	{
		return;
	}
	var controlData = $(task).data("controlData");
	var curPluginPanel = $("div#" + task.attr("pluginType") + "ActionConfig").show();
	$("div.pluginDetails").show();
	var pluginDetails = $("div#taskDetails");
	var inputs = pluginDetails.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(pluginDetails, controlData);
	if(task.attr("pluginType") == "zip")
	{
		if(controlData.internal_zip[0].text == "true")
		{
			checkUnchekInput(curPluginPanel.find("#internal_zip"), true);
		}
		else if(controlData.external_zip[0].text == "true")
		{
			checkUnchekInput(curPluginPanel.find("#external_zip"), true);
		}
	}
	else if(task.attr("pluginType") == "unzip")
	{
		if(controlData.internal_zip[0].text == "true")
		{
			checkUnchekInput(curPluginPanel.find("#internal_unzip"), true);
		}
		else if(controlData.external_zip[0].text == "true")
		{
			checkUnchekInput(curPluginPanel.find("#external_unzip"), true);
		}
	}
	else if(task.attr("pluginType") == "find")
	{
		if(controlData && controlData.modified_comparison)
		{
			if(controlData.modified_comparison[0].text == "new")
			{
				checkUnchekInput(curPluginPanel.find("#modified_comparison_newer"), true);
			}
			else
			{
				checkUnchekInput(curPluginPanel.find("#modified_comparison_older"), true);
			}
		}
	}
	else if(task.attr("pluginType") == "findcache")
	{
		if(controlData && controlData.cache_mode)
		{
			if(controlData.cache_mode[0].text == "write")
			{
				checkUnchekInput(curPluginPanel.find("#cache_mode_write"), true);
			}
			else
			{
				checkUnchekInput(curPluginPanel.find("#cache_mode_read"), true);
			}
		}
	}
	pluginDetails.find(".SSHOptionsHandle").trigger("textchange");
	inputs.addClass("ignoreBind");
}

pluginCrushTask.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginCrushTask.returnXML)
	{
		if(!pluginCrushTask.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");

		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<debug>"+$("#debug", _plugin).is(":checked")+"</debug>");
			xmlString.push("<enabled>"+$("#enabled", _plugin).is(":checked")+"</enabled>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			var tasksList = $("#tasksList", _plugin).find("li");
			if(tasksList.length>0)
			{
				xmlString.push("<tasks type=\"vector\">");
				tasksList.each(function(){
					xmlString.push("<tasks_subitem type=\"properties\">");
					var controlData = $(this).data("controlData");
					for(var item in controlData)
					{
						if(controlData[item].length)
						{
							if(typeof controlData[item][0].text != "undefined")
							{
								xmlString.push("<"+item+">"+ common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
							}
						}
					}
					xmlString.push("</tasks_subitem>");
				});
				xmlString.push("</tasks>");
			}
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");
		if(pluginCrushTask.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}